1 REM Insänd av Bert Holgersson <560>    1988-02-03 20.26.03 (DUMP)
;
;      Detta är mina personliga patchfiler, som jag på begäran,
;      härmed "offentliggör". Skulle någon ha vilja använda denna
;      och det uppstår frågetecken, så kontakata mig via MSG,
;      så skall jag försöka räta ut dem. Filen består av två sammanslagna
;      filer. "Delningspunkten" är betecknad med srängen "*_*_"
;      Filerna är urspringligen för ASMZ, men den var så dj-a, buggig,
;      så jag började använda ASS istället, därav "kommenteringen" av
;      ASMZ direktiven.
;
;=============================================================================
;
;        ZPROG  Ufdpatch
;
;                    PATCHNINGAR I UFDDOS FÖR ABC80
;                        Sist ändrad 87-02-12
;                         Bert Holgersson
;
;------------------------------------------------------------------------------
;
;             * *  Sammanfattning av gjortda ändringar * *
;
;    1  * Bug i CLOSE rutin fixad.
;    2  * Default device flyttat till normal plats i systemvariablerna.
;    3  * Enhetslista i RAM och brytmöjlighet i sektor read/write, flyttade.
;    4  * Random access rutiner rättade.
;    5  * Tabell som användes av DOSGEN640 inlagt
;    6  * Ctrl-C flag clearas vid initiering av DOS
;    7  * POKE arean lämnas opåverkad av DOS.(Overrides fix no. 3)
;
;------------------------------------------------------------------------------
;        Denna fil använder teknik med conditional assembly
;        Se ASMZ Manual.
;
;        De variabler som gäller är som följer:
;
;NOPOKE   EQU   1             ; Om man vill ha POKE arean helt fri
;POKE     EQU   0             ; Om man vill ha enhetstabell i POKE arean
;CTRLC    EQU   1             ; Om man vill att Ctrl-C flaggan skall nollas vid
;                               initiering av doset.
;------------------------------------------------------------------------------
;
; DR_: offset i doset:s enhetstabell
; Sätt DROFF att motsvara den typ av
; diskdrives som du har i ditt system
;
HDOFF    EQU  4              ; Winchester
MFOFF    EQU  8              ; ABC832
MOOFF    EQU  12             ; ABC830
SFOFF    EQU  16             ; ABC838
DROFF    EQU  MFOFF          ; DR_: = MF_:
;
;------------------------------------------------------------------------------
; - Fix no: 2 -
DEFDEV   EQU  64821          ; Ny adress för default device
;
;
;COND POKE
; - Fix no: 3 -
; Detta är gjort för att man skall ha
; kvar de första 64 bytes av POKE-arean
; på adress 65408.
;
;DEVDES   EQU  65472         ; Adress till enhetstabell i RAM
;RDWRET   EQU  65504         ; Adress till brytmöjlighet sect. read/write.
;ENDC
;
;COND NOPOKE
; - Fix no: 7 -
; Denna fix låter både enhetstabell och brytmöjligheten ligga kvar i DOS arean.
; Detta medför att om DOS ligger i ROM så kan man inte längre ändra DR_: offset
; eller använda brytmöjligheten. Under normala omständigheter spelar dock detta
; ingen roll utan allt fungerar som det brukar.
;
; Om man kör med DOS i RAM är dock allt precis som tidigare, frånsett att POKE
; arean får vara ifred.( Så att ouppfostrade program kan breda ut sig som de
; vill  )
;
; Tekniken är helt enkelt den att man använder den tabell som finns "bränd" i
; i DOS:et och som läggs ut i RAM vid initiering.
;
DEVDES  EQU  26506          ; Låter tabellen ligga kvar i DOS:et
RDWRET  EQU  26538          ; Brytmöjligheten ligger kvar i DOS arean.
;ENDC
;
; - Fix no: 4 -
;BUGGAR I RANDOM ACCESS RUTINER FIXADE
;Parameter i RA-read/write ignorerades
;Fel vid random access av filer med mer
;än ett segment.
;
TEMPWD   EQU  64794
;
;Doset skrev över pekaren till BASICens
;filbeskrivning.
;
         ORG  24683
         DEFW DEVDES
;
         ORG  24689
         DEFW RDWRET
;
         ORG  24795
         CALL RDWRET
;
         ORG  25040
         LD   HL,DEVDES
;
         ORG  25253
         LD   (TEMPWD),HL
;
         ORG  25264
         LD   HL,(TEMPWD)
;
         ORG  25938
         LD   DE,DEFDEV
;
         ORG  25949
         LD   DE,DEVDES
;
         ORG  25962
         LD   (DEFDEV),HL
;
; - Fix no: 2 -
         ORG  26210
         JP   BLKIN
         JP   BLKUT
;
         ORG  26241
         CALL M,23H
;
         ORG  26248
BLKIN:   XOR  A
BLIN1:   CALL BPOS
         CALL 24621
         AND  A
         JR   FBFIX
;
BLKUT:   XOR  A
BLUT1:   CALL BPOS
         CALL 24624
         SCF
FBFIX:   LD   H,(IX+9)
         LD   L,3
         RET  NC
         EX   DE,HL
         LD   A,1
         JR   26186
;
BPOS:    LD   B,(IX+12)
         AND  A
         RET  Z
         LD   A,D
         AND  E
         INC  A
         RET  Z
         JP   24618
;
         ORG  26468
         DEFW DEFDEV
;
         ORG  26506
         DEFB DROFF
;
         ORG  27892
         RET  Z
         NOP
;
         ORG  28607
         JP   C,BLIN1
         JP   BLUT1
;
;COND CTRLC
; - Fix no: 6 -
;------------------------------------------------------------------------------
;       Patch för att nolla Ctrl-C flag.
;       I vissa maskiner hamnar det skräp i minnet
;       vid spänningstillslag. Var flaggan >< 0 när
;       autostartprogrammet drogs igång så stannade
;       maskinen som om man tryckt Ctrl-C.
;
         ORG  26705
;
         CALL CLRCTRLC       ; Lägg in "omväg"
;ENDC
;
;------------------------------------------------------------------------------
;
;       Adress till fält med NOP:s i doset ( Tomt? )
;
         ORG  28571
;
;COND CTRLC
;
CTRLC?   EQU  830            ; Rutin i tolken

CLRCTRLC CALL CTRLC?         ; Clear Ctrl-C flag
         JP   (HL)           ; Fortsätt som ord. rutin ville
;ENDC
;
;COND NOPOKE
; - Fix no: 7 -
;
; UFD-entryt flyttas till ledigt område i doset, för att POKE
; arean skall få vara helt oanvänd. Detta medför att vid de
; tillfälen man inte har 64k RAM å kan man inte använda UFD:er
; Det medför också att program som inte använder pekaren i DOS:et,
; utan använder adreserna 65526 o.s.v direkt, kommer att gå galet.
; De flesta använder emellertid pekaren, så det blir antagligen
; inga problem.
;
UFDRES?  DEFB 0              ; Flagga för "Ej UFD reset"
UFDOFFS  DEFW 0              ; Sektor offset
UFDDRIVE DEFB 0              ; Selectkod för UFD-driven
;ENDC
;COND POKE
;UFDRES?  EQU  65526          ; Flagga för "Ej UFD reset"
;UFDOFFS  EQU  65527          ; Sektor offset
;UFDDRIVE EQU  65529          ; Selectkod för UFD-driven
;ENDC
; - Fix no: 5 -
;       Patch för att 640kB DOSGEN skall vara körbart
;       Inlagt av Bert Holgersson 86-08-08
;
         ORG  28591
;
         DEFB 44             ; Selectkod för MF_: ( 832 )
         DEFB  4             ; Clustersize för ovan !?
         DEFB 45             ; Selectkod för MO_: ( 830 )
         DEFB  4             ; ???
         DEFB 36             ; Selectkod för HD_: ( Winchester )
         DEFB 32             ; Clustersize för ovan !?
         DEFB 37             ; ???
         DEFB  1             ; ???
         DEFB  0             ; Terminering !?
;
;        Sätt de adresser som gäller för UFD-variablerna
;        Adresserna är definierade tidigare
;
         ORG   24685
         DEFW  UFDOFFS
;
         ORG   25095
         DEFW  UFDDRIVE
;
         ORG   25721
         DEFW  UFDOFFS
;
         ORG   25924
         DEFW  UFDRES?
;
         ORG   27245
         DEFW  UFDOFFS
;
         ORG   27820
         DEFW  UFDOFFS
;
         ORG   28249
         DEFW  UFDOFFS
;
         ORG   28489
         DEFW  UFDOFFS
;
        END
*_*_
;==============================================================================
;       ZPROG Timestamp
;
;                  * *   T I M E  S T A M P   * *
;
;                    Time stamp of DOS-files
;                    Bert Holgersson  86-03-01
;
;       There are three kinds of time stamps in the file:
;       1.   Prepare ( When file was created )
;       2.   Close Write ( Last written to file )
;       3.   Close Read  ( Last read from file )
;
;       Date and time are saved binary in 6 bytes in following order:
;       Year,month,day,hour,minute,second.
;
;       The stamps are in the file headerblock as follows:
;
;       Absolut      Relativ
;       adress in    adress from
;       DOSBUF 0     BUF strt.
;       --------     --------
;-------------- File created ------------
;       62940         220         Year
;       62941         221         Month
;       62942         222         Day
;       62943         223         Hour
;       62944         224         Minute
;       62945         225         Second
;---------------- Last write ------------
;       62946         226         Year
;       62947         227         Month
;       62948         228         Day
;       62949         229         Hour
;       62950         230         Minute
;       62951         231         Second
;--------------- Last read --------------
;       62952         232         Year
;       62953         233         Month
;       62954         234         Day
;       62955         235         Hour
;       62956         236         Minute
;       62957         237         Second
;------------------------------------------------------------------------------
;
OUTSTR   EQU  11             ; BASIC ROM print routine
RDHEADER EQU  28540          ; DOS routine. Gets fileheader to DOSBUF0
GETBUF   EQU  25098          ;  "     "     Gets adress to DOSBUF B*10H
WRSECT   EQU  24594          ; Writes sector DE, from DOSBUF B*10H
WRITIM   EQU  226            ; Offset to write stamp
RDTIM    EQU  232            ;   "    "  read    "
CRETIM   EQU  62940          ; Adress to create stamp. NB ! Always in DOSBUF 0
HEADSECT EQU  64776          ; Adress to headernumber in DOSDESC0
SELCODE  EQU  64769          ; Adress to disc select code in DOSDESC0
DISCERR  EQU  64789          ; Adress to disc error code
;
;------------------------------------------------------------------------------
;             ***  D O S  P A T C H E S  ***
;
        ORG  27892           ; Patch to remove old patch !!
        JR   Z,27902         ; Original instruktion that has been patched away
;
;       Patch for "detour" in CLOSE routine
;
        ORG   27903          ; Adress for DIAB ABC80 UFD-dos
        DEFW LASTDAT         ; Adress to "stamp" routine
;
;       Patch for "detour" in PREPARE rutine
;
        ORG   27349          ; Adress for DIAB ABC80 UFD-dos
        DEFW PREPDAT         ; Adress to "stamp" routine
;
;------------------------------------------------------------------------------
;             *** C L O S E  T I M E S T A M P ***
;
        ORG   20480          ; Beginning of external CMOS memory
;
;       You can place the routine wherever you have place for it,
;       just change the ORG statement above
;
LASTDAT PUSH  BC
        PUSH  DE
        PUSH  HL
;
        CALL RDHEADER        ; Get file header block
        PUSH AF              ; Save result for DOS
        JR   C,STMPERR       ; Jump if error occured
;
        LD   HL,SELCODE
        BIT  5,(HL)          ; Written to file ?
        LD    DE,WRITIM      ; Offset to "Last written" time
        JR    Z,TOBUFF       ; Jump if written to file
;
        LD    DE,RDTIM       ; If read from file, use another offset
TOBUFF  LD    L,0            ; Clear L
        CALL  GETBUF         ; Get adress to "our" DOSBUF:fer
        ADD   HL,DE          ; HL:= Adress where to put time stamp
        EX    DE,HL          ; But it shoud be DE that points to destination
        CALL  STAMP          ; Copy kalendar data to header block
;
        LD    DE,(HEADSECT)  ; Get sectorno for headerblock
        CALL  WRSECT         ; Write headersector to disc
        JR    C,STMPERR      ; Tell operator, impossible to stamp file
;
        JR   OUT
;
;------------------------------------------------------------------------------
;             *** P R E P A R E   T I M E S T A M P  ***
;
PREPDAT PUSH  BC
        PUSH  HL
;
        LD    DE,CRETIM
        CALL  STAMP
        LD    DE,(64776)     ; Instruktion spoiled  by patch
;
        POP    HL
        POP    BC
;
        JP   24784           ; Continue in ord. routine
;
;-------------------------------------------------------------------------------
;
;       IN: DE = destination for stamp data
;
STAMP   LD    HL,SYSTIME     ; System time
        LD    BC,6           ; Number of bytes
        LDIR                 ; Move system time to time stamp area in buffer
        RET
;
;-------------------------------------------------------------------------------
;
MESSAGE DEFB  7
        DEFB  13
        DEFB  10
        DEFB  10
        DEFM  "**  Impossible to timestamp file  **"
        DEFB  13
        DEFB  10
MESSLEN EQU   ¤-MESSAGE
ERRFLAG DEFB  0              ; Flag for "Fatal error"
;
STMPERR LD    HL,MESSAGE
        LD    BC,MESSLEN
        CALL  OUTSTR
;
; * *   D e l a y  l o o p   * * *
;
        LD    B,2            ; Create delay to give the operator a chance
LOOP1   LD    HL,0           ; to catch the message
LOOP    DEC   HL
        LD    A,L
        OR    H
        JR    NZ,LOOP
        DJNZ  LOOP1
;
; * *   E n d   o f  d e l a y   * *
;
        LD   A,(DISCERR)     ; Get disc error code
        BIT  6,A             ; Write protect ?
        JR   NZ,SKIP         ; Write protect is a non fatal error
;
; This is exit _BOTH_ with all ok. AND fatal error
;
OUT     POP  AF              ; Get result and giv to DOS
        POP  HL
        POP  DE
        POP  BC
        RET                  ; Continue in ord. routine
;
; This is exit at Non fatal error (i.e. Write protect)
;
SKIP    POP  AF
        POP  HL
        POP  DE
        POP  BC
;
        XOR  A               ; Fool DOS that's everything is allright
        INC  SP              ; And skip, rest of close routine. It will
        INC  SP              ; only try to write on disc, anyway.
        RET                  ; Back from CLOSE routine. All OK !
;
;-------------------------------------------------------------------------------
;
;       "System time" used during development
;
;SYSTIME DEFB  86             ; Year
;        DEFB  03             ; Month
;        DEFB  01             ; Day
;        DEFB  23             ; Hour
;        DEFB  10             ; Minute
;        DEFB  20             ; Second
;
        END

END OF FILE

Éwho

          7  KNUT
===>     15  HOLGERSSON
        670  SYSTEM
        672  SYSTEM
Éter-st,,

 LOG.NO  USER            MODE    CPU-MIN OUT OF  LAST COMMAND
      7 KNUT             USER         1     41  CC <NOTIS WP> CC
     15 HOLGERSSON       COMMAND      0     14  TER-ST,,
    670 SYSTEM           COMMAND      0    436
    672 SYSTEM           COMMAND      0    436

Élog
 22.33.05      2 FEBRUARY   1988
--EXIT--


